diff --git a/web/regression/javascript/table/enable_disable_triggers_spec.js b/web/regression/javascript/table/enable_disable_triggers_spec.js
new file mode 100644
index 00000000..7bdd284e
--- /dev/null
+++ b/web/regression/javascript/table/enable_disable_triggers_spec.js
@@ -0,0 +1,271 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2018, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import MockAdapter from 'axios-mock-adapter';
+import axios from 'axios/index';
+import {
+  enableTriggers,
+  disableTriggers,
+} from '../../../pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/enable_disable_triggers';
+import {TreeFake} from '../tree/tree_fake';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+
+describe('#enableTriggers', () => {
+  let networkMock;
+  let tree;
+  let alertify;
+  let generateUrlSpy;
+  beforeEach(() => {
+    networkMock = new MockAdapter(axios);
+    tree = new TreeFake();
+    const server1 = tree.addNewNode('server1', {_id: 1}, ['<li>server1</li>']);
+    const database1 = tree.addNewNode('database1', {_type: 'database'}, ['<li>database1</li>']);
+    tree.addChild(server1, database1);
+
+    const schema1 = tree.addNewNode('schema1', {_type: 'schema'}, ['<li>schema1</li>']);
+    tree.addChild(database1, schema1);
+
+    const table1 = tree.addNewNode('table1', {_type: 'table'}, ['<li>table1</li>']);
+    tree.addChild(schema1, table1);
+
+    const column1 = tree.addNewNode('column1', {_type: 'column'}, ['<li>column1</li>']);
+    tree.addChild(table1, column1);
+
+    const tableNoData = tree.addNewNode('table-no-data', undefined, ['<li>table-no-data</li>']);
+    tree.addChild(schema1, tableNoData);
+
+    alertify = jasmine.createSpyObj('alertify', ['success', 'error']);
+    generateUrlSpy = jasmine.createSpy('generateUrl');
+    generateUrlSpy.and.returnValue('/some/place');
+  });
+
+  describe('no node is selected', () => {
+    it('does not send the request to the backend', (done) => {
+      networkMock.onAny('.*').reply(200, () => {
+      });
+
+      setTimeout(() => {
+        expect(enableTriggers(tree, alertify, generateUrlSpy, {})).toBe(false);
+        done();
+      }, 0);
+    });
+  });
+
+  describe('a node is selected', () => {
+    describe('node as no data', () => {
+      it('does not send the request to the backend', () => {
+        tree.selectNode([{id: 'table-no-data'}]);
+
+        networkMock.onAny('.*').reply(200, () => {
+        });
+
+        setTimeout(() => {
+          expect(enableTriggers(tree, alertify, generateUrlSpy, {})).toBe(false);
+        }, 0);
+      });
+    });
+
+    describe('node as  data', () => {
+      describe('backend responds with success', () => {
+        let networkMockCalledWith;
+        beforeEach(() => {
+          networkMockCalledWith = false;
+          networkMock.onPut(/.*/).reply((configuration) => {
+            networkMockCalledWith = configuration;
+            return [200, {
+              success: 1,
+              info: 'some information',
+            }];
+          });
+        });
+
+        it('displays an alert box with success', (done) => {
+          tree.selectNode([{id: 'table1'}]);
+          enableTriggers(tree, alertify, generateUrlSpy, {});
+          setTimeout(() => {
+            expect(alertify.success).toHaveBeenCalledWith('some information');
+            done();
+          }, 0);
+        });
+
+        it('reloads the node', (done) => {
+          enableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+          setTimeout(() => {
+            expect(tree.selected()).toEqual(['<li>table1</li>']);
+            done();
+          }, 20);
+        });
+
+        it('call backend with the correct parameters', (done) => {
+          enableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+          setTimeout(() => {
+            expect(networkMockCalledWith.data).toEqual(JSON.stringify({enable: 'true'}));
+            done();
+          }, 0);
+        });
+      });
+
+      describe('backend responds with error', () => {
+        beforeEach(() => {
+          networkMock.onPut(/.*/).reply(() => {
+            return [500, {
+              success: 0,
+              errormsg: 'some error message',
+            }];
+          });
+        });
+
+        it('displays an error alert', (done) => {
+          tree.selectNode([{id: 'table1'}]);
+          enableTriggers(tree, alertify, generateUrlSpy, {});
+          setTimeout(() => {
+            expect(alertify.error).toHaveBeenCalledWith('some error message');
+            done();
+          }, 0);
+        });
+
+        it('unload the node', (done) => {
+          enableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+
+          setTimeout(() => {
+            expect(tree.findNodeByDomElement([{id: 'table1'}]).children.length).toBe(0);
+            done();
+          }, 20);
+        });
+      });
+    });
+  });
+});
+
+describe('#disableTriggers', () => {
+  let networkMock;
+  let tree;
+  let alertify;
+  let generateUrlSpy;
+  beforeEach(() => {
+    networkMock = new MockAdapter(axios);
+    tree = new TreeFake();
+    const server1 = tree.addNewNode('server1', {_id: 1}, ['<li>server1</li>']);
+    const database1 = new TreeNode('database1', {_type: 'database'}, ['<li>database1</li>']);
+    tree.addChild(server1, database1);
+
+    const schema1 = new TreeNode('schema1', {_type: 'schema'}, ['<li>schema1</li>']);
+    tree.addChild(database1, schema1);
+
+    const table1 = new TreeNode('table1', {_type: 'table'}, ['<li>table1</li>']);
+    tree.addChild(schema1, table1);
+
+    const column1 = new TreeNode('column1', {_type: 'column'}, ['<li>column1</li>']);
+    tree.addChild(table1, column1);
+
+    const tableNoData = new TreeNode('table-no-data', undefined, ['<li>table-no-data</li>']);
+    tree.addChild(schema1, tableNoData);
+
+    alertify = jasmine.createSpyObj('alertify', ['success', 'error']);
+    generateUrlSpy = jasmine.createSpy('generateUrl');
+    generateUrlSpy.and.returnValue('/some/place');
+  });
+
+  describe('no node is selected', () => {
+    it('does not send the request to the backend', (done) => {
+      networkMock.onAny('.*').reply(200, () => {
+      });
+
+      setTimeout(() => {
+        expect(disableTriggers(tree, alertify, generateUrlSpy, {})).toBe(false);
+        done();
+      }, 0);
+    });
+  });
+
+  describe('a node is selected', () => {
+    describe('node as no data', () => {
+      it('does not send the request to the backend', () => {
+        tree.selectNode([{id: 'table-no-data'}]);
+
+        networkMock.onAny('.*').reply(200, () => {
+        });
+
+        setTimeout(() => {
+          expect(disableTriggers(tree, alertify, generateUrlSpy, {})).toBe(false);
+        }, 0);
+      });
+    });
+
+    describe('node as  data', () => {
+      describe('backend responds with success', () => {
+        let networkMockCalledWith;
+        beforeEach(() => {
+          networkMockCalledWith = false;
+          networkMock.onPut(/.*/).reply((configuration) => {
+            networkMockCalledWith = configuration;
+            return [200, {
+              success: 1,
+              info: 'some information',
+            }];
+          });
+        });
+
+        it('displays an alert box with success', (done) => {
+          tree.selectNode([{id: 'table1'}]);
+          disableTriggers(tree, alertify, generateUrlSpy, {});
+          setTimeout(() => {
+            expect(alertify.success).toHaveBeenCalledWith('some information');
+            done();
+          }, 0);
+        });
+
+        it('reloads the node', (done) => {
+          disableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+          setTimeout(() => {
+            expect(tree.selected()).toEqual(['<li>table1</li>']);
+            done();
+          }, 20);
+        });
+
+        it('call backend with the correct parameters', (done) => {
+          disableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+          setTimeout(() => {
+            expect(networkMockCalledWith.data).toEqual(JSON.stringify({enable: 'false'}));
+            done();
+          }, 0);
+        });
+      });
+
+      describe('backend responds with error', () => {
+        beforeEach(() => {
+          networkMock.onPut(/.*/).reply(() => {
+            return [500, {
+              success: 0,
+              errormsg: 'some error message',
+            }];
+          });
+        });
+
+        it('displays an error alert', (done) => {
+          tree.selectNode([{id: 'table1'}]);
+          disableTriggers(tree, alertify, generateUrlSpy, {});
+          setTimeout(() => {
+            expect(alertify.error).toHaveBeenCalledWith('some error message');
+            done();
+          }, 0);
+        });
+
+        it('unload the node', (done) => {
+          disableTriggers(tree, alertify, generateUrlSpy, {item: [{id: 'table1'}]});
+
+          setTimeout(() => {
+            expect(tree.findNodeByDomElement([{id: 'table1'}]).children.length).toBe(0);
+            done();
+          }, 20);
+        });
+      });
+    });
+  });
+});
diff --git a/web/regression/javascript/tree/pgadmin_tree_node_spec.js b/web/regression/javascript/tree/pgadmin_tree_node_spec.js
new file mode 100644
index 00000000..479e515c
--- /dev/null
+++ b/web/regression/javascript/tree/pgadmin_tree_node_spec.js
@@ -0,0 +1,353 @@
+//////////////////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2018, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////////////////
+
+import {
+  getTreeNodeHierarchyFromElement,
+  getTreeNodeHierarchyFromIdentifier,
+} from '../../../pgadmin/static/js/tree/pgadmin_tree_node';
+import {TreeNode} from '../../../pgadmin/static/js/tree/tree';
+import {TreeFake} from './tree_fake';
+
+const context = describe;
+
+describe('tree#node#getTreeNodeHierarchy', () => {
+  let browser;
+  let newTree;
+  beforeEach(() => {
+    newTree = new TreeFake();
+    browser = {
+      Nodes: {
+        'special one': {hasId: true},
+        'child special': {hasId: true},
+        'other type': {hasId: true},
+        'table': {hasId: true},
+        'partition': {hasId: true},
+        'no id': {hasId: false},
+      },
+    };
+    browser.treeMenu = newTree;
+  });
+
+  context('getTreeNodeHierarchy is called with aciTreeNode object', () => {
+    describe('When the current node is root element', () => {
+      beforeEach(() => {
+        newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'special one',
+        });
+      });
+
+      it('returns a object with the element type passed data and priority == 0', () => {
+        const result = getTreeNodeHierarchyFromIdentifier.bind(browser)([{id: 'root'}]);
+        expect(result).toEqual({
+          'special one': {
+            'some key': 'some value',
+            '_type': 'special one',
+            'priority': 0,
+          },
+        });
+      });
+    });
+
+    describe('When the current node is not of a known type', () => {
+      beforeEach(() => {
+        newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'do not exist',
+        }, []);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromIdentifier.bind(browser)('root');
+        expect(result).toEqual({});
+      });
+    });
+
+    describe('When the current node type has no id', () => {
+      beforeEach(() => {
+        newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'no id',
+        }, []);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromIdentifier.bind(browser)('root');
+        expect(result).toEqual({});
+      });
+    });
+
+    describe('When the current node is at the second level', () => {
+      beforeEach(() => {
+        const root = newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'special one',
+        });
+        const firstChild = new TreeNode('first child', {
+          'some key': 'some other value',
+          '_type': 'child special',
+        }, ['root']);
+        newTree.addChild(root, firstChild);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromIdentifier.bind(browser)([{id: 'first child'}]);
+        expect(result).toEqual({
+          'child special': {
+            'some key': 'some other value',
+            '_type': 'child special',
+            'priority': 0,
+          },
+          'special one': {
+            'some key': 'some value',
+            '_type': 'special one',
+            'priority': -1,
+          },
+        });
+      });
+    });
+
+    context('When tree as "special type"', () => {
+      context('When "special type" have "other type"', () => {
+        context('When "other type" have "special type"', () => {
+          describe('When retrieving lead node', () => {
+            it('does not override previous node type data', () => {
+              const rootNode = newTree.addNewNode('root', {
+                'some key': 'some value',
+                '_type': 'special one',
+              }, []);
+
+              const level1 = new TreeNode('level 1', {
+                'some key': 'some value',
+                '_type': 'other type',
+              });
+              newTree.addChild(rootNode, level1);
+
+              newTree.addChild(level1, new TreeNode('level 2', {
+                'some key': 'expected value',
+                '_type': 'special one',
+                'some other key': 'some other value',
+              }));
+
+              const result = getTreeNodeHierarchyFromIdentifier.bind(browser)([{id: 'level 2'}]);
+              expect(result).toEqual({
+                'special one': {
+                  'some key': 'expected value',
+                  '_type': 'special one',
+                  'some other key': 'some other value',
+                  'priority': 0,
+                },
+                'other type': {
+                  'some key': 'some value',
+                  '_type': 'other type',
+                  'priority': -1,
+                },
+              });
+            });
+          });
+        });
+      });
+    });
+
+    context('When tree has table', () => {
+      context('when table has partition', () => {
+        it('returns table with partition parameters', () => {
+          const root = newTree.addNewNode('root', {
+            'some key': 'some value',
+            '_type': 'special one',
+          }, []);
+          const level1 = new TreeNode('level 1', {
+            'some key': 'some value',
+            '_type': 'table',
+          });
+          newTree.addChild(root, level1);
+          newTree.addChild(level1, new TreeNode('level 2', {
+            'some key': 'expected value',
+            '_type': 'partition',
+            'some other key': 'some other value',
+          }));
+
+          const result = getTreeNodeHierarchyFromIdentifier.bind(browser)([{id:'level 2'}]);
+          expect(result).toEqual({
+            'special one': {
+              'some key': 'some value',
+              '_type': 'special one',
+              'priority': -1,
+            },
+            'table': {
+              'some key': 'expected value',
+              'some other key': 'some other value',
+              '_type': 'partition',
+              'priority': 0,
+            },
+          });
+        });
+      });
+    });
+  });
+
+  context('getTreeNodeHierarchy is called with TreeNode object', () => {
+    let treeNode;
+    describe('When the current node is root element', () => {
+      beforeEach(() => {
+        treeNode = newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'special one',
+        }, []);
+      });
+
+      it('returns a object with the element type passed data and priority == 0', () => {
+        const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+        expect(result).toEqual({
+          'special one': {
+            'some key': 'some value',
+            '_type': 'special one',
+            'priority': 0,
+          },
+        });
+      });
+    });
+
+    describe('When the current node is not of a known type', () => {
+      beforeEach(() => {
+        treeNode = newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'do not exist',
+        }, []);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+        expect(result).toEqual({});
+      });
+    });
+
+    describe('When the current node type has no id', () => {
+      beforeEach(() => {
+        treeNode = newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'no id',
+        }, []);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+        expect(result).toEqual({});
+      });
+    });
+
+    describe('When the current node is at the second level', () => {
+      beforeEach(() => {
+        const root = newTree.addNewNode('root', {
+          'some key': 'some value',
+          '_type': 'special one',
+        }, []);
+        treeNode = new TreeNode('first child', {
+          'some key': 'some other value',
+          '_type': 'child special',
+        });
+        newTree.addChild(root, treeNode);
+      });
+
+      it('returns a empty object', () => {
+        const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+        expect(result).toEqual({
+          'child special': {
+            'some key': 'some other value',
+            '_type': 'child special',
+            'priority': 0,
+          },
+          'special one': {
+            'some key': 'some value',
+            '_type': 'special one',
+            'priority': -1,
+          },
+        });
+      });
+    });
+
+    context('When tree as "special type"', () => {
+      context('When "special type" have "other type"', () => {
+        context('When "other type" have "special type"', () => {
+          describe('When retrieving lead node', () => {
+            it('does not override previous node type data', () => {
+              const root = newTree.addNewNode('root', {
+                'some key': 'some value',
+                '_type': 'special one',
+              }, []);
+              const level1 = new TreeNode('level 1', {
+                'some key': 'some value',
+                '_type': 'other type',
+              });
+              newTree.addChild(root, level1);
+              treeNode = new TreeNode('level 2', {
+                'some key': 'expected value',
+                '_type': 'special one',
+                'some other key': 'some other value',
+              });
+              newTree.addChild(level1, treeNode);
+
+              const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+              expect(result).toEqual({
+                'special one': {
+                  'some key': 'expected value',
+                  '_type': 'special one',
+                  'some other key': 'some other value',
+                  'priority': 0,
+                },
+                'other type': {
+                  'some key': 'some value',
+                  '_type': 'other type',
+                  'priority': -1,
+                },
+              });
+            });
+          });
+        });
+      });
+    });
+
+    context('When tree has table', () => {
+      context('when table has partition', () => {
+        it('returns table with partition parameters', () => {
+          const root = newTree.addNewNode('root', {
+            'some key': 'some value',
+            '_type': 'special one',
+          });
+          const level1 = newTree.addNewNode('level 1', {
+            'some key': 'some value',
+            '_type': 'table',
+          });
+          newTree.addChild(root, level1);
+          treeNode = new TreeNode('level 2', {
+            'some key': 'expected value',
+            '_type': 'partition',
+            'some other key': 'some other value',
+          });
+          newTree.addChild(level1, treeNode);
+
+          const result = getTreeNodeHierarchyFromElement(browser, treeNode);
+          expect(result).toEqual({
+            'special one': {
+              'some key': 'some value',
+              '_type': 'special one',
+              'priority': -1,
+            },
+            'table': {
+              'some key': 'expected value',
+              'some other key': 'some other value',
+              '_type': 'partition',
+              'priority': 0,
+            },
+          });
+        });
+      });
+    });
+  });
+});
diff --git a/web/regression/javascript/tree/tree_fake.js b/web/regression/javascript/tree/tree_fake.js
index b285a45f..e03d71fb 100644
--- a/web/regression/javascript/tree/tree_fake.js
+++ b/web/regression/javascript/tree/tree_fake.js
@@ -10,6 +10,32 @@
 import {Tree} from '../../../pgadmin/static/js/tree/tree';
 
 export class TreeFake extends Tree {
+  static build(structure) {
+    let tree = new TreeFake();
+    let rootNode = tree.rootNode;
+
+    if (structure.children !== undefined) {
+      structure.children.forEach((child) => {
+        TreeFake.recursivelyAddNodes(tree, child, rootNode);
+      });
+    }
+
+    return tree;
+  }
+
+  static recursivelyAddNodes(tree, newNode, parent) {
+    let id = newNode.id;
+    let data = newNode.data ? newNode.data : {};
+    let domNode = newNode.domNode ? newNode.domNode : [{id: id}];
+    tree.addNewNode(id, data, domNode, tree.translateTreeNodeIdFromACITree([parent]));
+
+    if (newNode.children !== undefined) {
+      newNode.children.forEach((child) => {
+        TreeFake.recursivelyAddNodes(tree, child, newNode);
+      });
+    }
+  }
+
   constructor() {
     super();
     this.aciTreeToOurTreeTranslator = {};
@@ -45,7 +71,7 @@ export class TreeFake extends Tree {
   }
 
   translateTreeNodeIdFromACITree(aciTreeNode) {
-    if(aciTreeNode === undefined || aciTreeNode[0] === undefined) {
+    if (aciTreeNode === undefined || aciTreeNode[0] === undefined) {
       return null;
     }
     return this.aciTreeToOurTreeTranslator[aciTreeNode[0].id];
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 64f24336..c12e7f3b 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -130,6 +130,7 @@ var webpackShimConfig = {
     'sources/utils': path.join(__dirname, './pgadmin/static/js/utils'),
     'babel-polyfill': path.join(__dirname, './node_modules/babel-polyfill/dist/polyfill'),
     'tools': path.join(__dirname, './pgadmin/tools/'),
+    'pgbrowser': path.join(__dirname, './pgadmin/browser/static/js/'),
 
     // Vendor JS
     'jquery': path.join(__dirname, './node_modules/jquery/dist/jquery'),
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index 1b374d62..e78e53e0 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -80,6 +80,8 @@ module.exports = {
       'pgadmin.alertifyjs': sourcesDir + '/js/alertify.pgadmin.defaults',
       'pgadmin.backgrid': sourcesDir + '/js/backgrid.pgadmin',
       'pgadmin.backform': sourcesDir + '/js/backform.pgadmin',
+      'pgbrowser': path.resolve(__dirname, 'regression/javascript/fake_browser'),
+      'pgadmin.schema.dir': path.resolve(__dirname, 'pgadmin/browser/server_groups/servers/databases/schemas/static/js'),
     },
   },
 };
